#!***************************************************************************************************************************
#TEMPLATE(EasyWinIco,'Easy Animated Window Icon - FREEWARE'),FAMILY('ABC'),FAMILY('CW20')
#HELP('EasyWI.hlp')
#!***************************************************************************************************************************
#EXTENSION(EasyWinIco,'Easy Animated Window Icon - FREEWARE'),PROCEDURE
#!---------------------------------------------------------------------------------------------------------------------------
  #SHEET
    #TAB('General'), hlp('~Templates')
      #BOXED('')
        #DISPLAY('This template allows to associate')
        #DISPLAY('an animated icon with the window')
        #DISPLAY('(which located in the left top corner of a window.)')
        #DISPLAY
        #DISPLAY('The template uses a set of icons.')
        #DISPLAY('Names of icons of a set should:')
        #DISPLAY('1. have the identical beginning of a name')
        #DISPLAY('2. be ended by two characters with number')
        #DISPLAY('   of an icon in a set')
        #DISPLAY
        #DISPLAY('For example:')
        #DISPLAY('ImgXX01.ico, ImgXX02.ico and so on')
      #ENDBOXED
      #DISPLAY
      #!
      #PROMPT('First ICO: ', OPENDIALOG('Pick first ICO-file','ICO-files|*.ico')),%FirstIcoName, REQ, AT(65,,120)
      #VALIDATE(%CheckIcoName(1), 'Incorrect ICO file name')
      #!
      #PROMPT('Last  ICO: ', OPENDIALOG('Pick last ICO-file','ICO-files|*.ico')),%LastIcoName,   REQ, AT(65,,120)
      #VALIDATE(%CheckIcoName(2), 'Incorrect ICO file name')
      #!
      #PROMPT('Timer:',      SPIN(@N3, 1, 350)),%Ticks,DEFAULT(20), REQ, AT(65,,30)
    #ENDTAB
    #TAB('About'), hlp('~Templates')
      #DISPLAY
      #IMAGE('IngaSoftWI.gif')
      #DISPLAY('EasyWinIco - Animated Window Icon'),AT(20)
      #DISPLAY('Version 1.00 (freeware)'),AT(117)
      #DISPLAY('IngaSoftPlus Company'),AT(20)
      #DISPLAY('Copyright  2002 All Rights Reserved'),AT(20)
      #DISPLAY
      #DISPLAY
      #DISPLAY('WARNING')
      #DISPLAY('This product is protected by copyright and international')
      #DISPLAY('law.')
      #DISPLAY('You may use it in your applications without charge - but')
      #DISPLAY('you do so at your own risk!  No liabilities accepted.')
      #DISPLAY('No charge may be made for distributing this template.')
      #DISPLAY
      #DISPLAY('http://www.ingasoftplus.com'),AT(20)
      #DISPLAY('e-mail: support@ingasoftplus.com'),AT(20)
      #DISPLAY
    #ENDTAB
  #ENDSHEET
#!---------------------------------------------------------------------------------------------------------------------------
#ATSTART
  #CALL(%FillData)
#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
  #CALL(%FillData)
  #!
  #LOOP,FOR(%LoopCount, %FirstIcoNum, %LastIcoNum)
    #PROJECT(%WinIcoPrefix & FORMAT(%LoopCount, @N02) & '.ico')
  #ENDLOOP
#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------
#AT(%DataSectionBeforeWindow)
WinIcoGrp            GROUP,PRE(WinIco)
TickCount              LONG(%FirstIcoNum)
TickMulti              LONG(1)
TickMultiCount         LONG(1)
                     END
#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------
#AT(%AfterWindowOpening)
TARGET{PROP:Icon}  = '~%FirstIcoName'
#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------
#AT(%PostWindowEventHandling,'OpenWindow'),LAST
IF TARGET{PROP:Timer} = 0
   TARGET{PROP:Timer} = %Ticks
ELSE
   WinIco:TickMulti   = %Ticks / TARGET{PROP:Timer}
   IF WinIco:TickMulti = 0
      WinIco:TickMulti = 1
   END
END
#ENDAT
#!---------------------------------------------------------------------------------------------------------------------------
#AT(%AcceptLoopBeforeEventHandling)
IF EVENT() = EVENT:Timer
   IF WinIco:TickMultiCount = WinIco:TickMulti
      WinIco:TickMultiCount = 1
      IF INRANGE(WinIco:TickCount, %FirstIcoNum, %LastIcoNum - 1)
         WinIco:TickCount += 1
      ELSE
         WinIco:TickCount  = %FirstIcoNum
      END
      TARGET{PROP:Icon} = '~%WinIcoPrefix' & CLIP(FORMAT(WinIco:TickCount, @N02)) & '.ico'
      DISPLAY
   ELSE
      WinIco:TickMultiCount += 1
   END
END
#ENDAT
#!***************************************************************************************************************************
#GROUP(%CheckIcoName,%NumIco) #! Check ICO-file name
#!---------------------------------------------------------------------------------------------------------------------------
 #CASE(%NumIco)
   #OF(1) #! First ICO
      #IF(LEN(CLIP(%FirstIcoName)) > 5 AND UPPER(SUB(%FirstIcoName, LEN(CLIP(%FirstIcoName)) - 3, 4)) = '.ICO')
        #RETURN(%True)
      #ENDIF
   #OF(2) #! Last  ICO
      #IF(LEN(CLIP(%LastIcoName)) > 5 AND UPPER(SUB(%LastIcoName, LEN(CLIP(%LastIcoName)) - 3, 4)) = '.ICO' AND UPPER(SUB(%FirstIcoName, 1, LEN(CLIP(%FirstIcoName)) - 6)) = UPPER(SUB(%LastIcoName, 1, LEN(CLIP(%LastIcoName)) - 6)))
        #RETURN(%True)
      #ENDIF
 #ENDCASE
 #RETURN(%False)
#!***************************************************************************************************************************
#GROUP(%FillData) #! Fill data
#!---------------------------------------------------------------------------------------------------------------------------
  #IF(NOT VAREXISTS(%FirstIcoNum))
    #DECLARE(%FirstIcoNum, LONG)
    #DECLARE(%LastIcoNum,  LONG)
    #DECLARE(%LoopCount,   LONG)
    #DECLARE(%WinIcoPrefix)
    #!
    #SET(%FirstIcoNum,  DEFORMAT(SUB(%FirstIcoName, LEN(CLIP(%FirstIcoName)) - 5, 2), @N02))
    #SET(%LastIcoNum,   DEFORMAT(SUB(%LastIcoName,  LEN(CLIP(%LastIcoName))  - 5, 2), @N02))
    #SET(%WinIcoPrefix, SUB(%FirstIcoName, 1, LEN(CLIP(%FirstIcoName)) - 6))
  #ENDIF
#!***************************************************************************************************************************
